#import <Cocoa/Cocoa.h>
#import <QuartzCore/QuartzCore.h>
#import <Foundation/Foundation.h>

//////////////////////////////////////////////////////////////////////////
//
// NOTE:  This is a work in progress.  Expect this interface to change.
//
//////////////////////////////////////////////////////////////////////////

@class CTOffscreenContext;
@class SimpleQCRenderer;
@class CTFBOContext;

@interface CTContext : NSObject 
{
	CGSize size;

	CTFBOContext *fboCtx;
	CIContext *ciCtx;

	SimpleQCRenderer	*renderer;

	double				frameTime;
	BOOL				bForPreview;
}

+ (void) clearContext:(CGLContextObj) oglCtx
				toRed:(GLfloat)	red
				green:(GLfloat) green
				 blue:(GLfloat) blue
				alpha:(GLfloat) alpha;

+ (void) drawTexture:(GLuint) tname
			fromRect:(CGRect) fromRect
		   toContext:(CGLContextObj) otherContext
			  inRect:(CGRect) inRect
			 flipped:(BOOL) flipped
			mirrored:(BOOL) mirrored
			blending:(BOOL) blending;

+ (void) drawTexture:(GLuint) tname
		   toContext:(CGLContextObj) otherContext
			 flipped:(BOOL) flipped
			mirrored:(BOOL) mirrored;

- (void) setFrameTime:(double) time;
- (double) frameTime;

// When an effect is in Program, it will also be shown on
// the preview monitor.  Some effects may want to know when
// they're being rendered on the Preview monitor.  Note that
// rendering different content in different modes in generally
// discouraged.  The promice of the Preview monotor is to 
// show what will end up in Program after a transition.
// Despite that, there are some valid use-cases for rendering
// slighly different content while for Preview.
// When we're rendering for preview, isForPreview will be YES.
- (BOOL) isForPreview;
- (void) setIsForPreview:(BOOL) b;

// Reset back to a known state
- (void) clear:(BOOL) clearAlpha;

- (CGSize) size;

- (CGColorSpaceRef) colorSpace;

- (NSOpenGLContext *) oglCtx;
- (NSOpenGLPixelFormat *) oglFmt;
- (CIContext *) ciCtx;

- (void) saveToPNG:(NSString *) path;

- (BOOL) isComplete;
- (GLuint) texture;
- (CIImage *) textureAsImageHelper:(GLuint) txt;
- (GLuint) stealTexture:(BOOL) clearNewAlpha;	// You must delete!
- (void) setTexture:(GLuint) texture;
- (void) deleteTextureHelper:(GLuint) texture;

- (void) setQCRenderer:(SimpleQCRenderer *) rend;
- (SimpleQCRenderer *) qcRenderer;

- (void) drawTexture:(GLuint) texture
			  inRect:(CGRect) inRect
			fromRect:(CGRect) fromRect;

- (void) renderToContext:(CGLContextObj) otherContext;

- (void) flush;

- (void) fetchOpenGLPixels:(void *) data
				  rowBytes:(GLint) rowBytes;

@end
